/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { CdkConnectedOverlay, CdkOverlayOrigin, ConnectedOverlayPositionChange, ConnectionPositionPair } from '@angular/cdk/overlay';
import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit, QueryList, SimpleChanges } from '@angular/core';
import { CandyDate, CompatibleValue } from 'ng-zorro-antd/core/time';
import { DateHelperService } from 'ng-zorro-antd/i18n';
import { Subject } from 'rxjs';
import { DatePickerService } from './date-picker.service';
import { RangePartType } from './standard-types';
export declare class NzPickerComponent implements OnInit, AfterViewInit, OnChanges, OnDestroy {
    private elementRef;
    private dateHelper;
    private changeDetector;
    datePickerService: DatePickerService;
    noAnimation: boolean;
    isRange: boolean;
    open: boolean | undefined;
    disabled: boolean;
    disabledDate: (current: Date) => boolean;
    placeholder: string | string[];
    allowClear: boolean;
    autoFocus: boolean;
    format: string;
    separator: string;
    readonly focusChange: EventEmitter<boolean>;
    readonly valueChange: EventEmitter<CandyDate | CandyDate[] | null>;
    readonly openChange: EventEmitter<boolean>;
    cdkConnectedOverlay: CdkConnectedOverlay;
    separatorElement: ElementRef;
    rangePickerInputs: QueryList<ElementRef>;
    origin: CdkOverlayOrigin;
    inputSize: number;
    destroy$: Subject<unknown>;
    prefixCls: string;
    inputValue: any;
    activeBarStyle: object;
    animationOpenState: boolean;
    overlayOpen: boolean;
    overlayPositions: ConnectionPositionPair[];
    dropdownAnimation: 'top' | 'bottom';
    currentPositionX: 'start' | 'end';
    currentPositionY: 'top' | 'bottom';
    get realOpenState(): boolean;
    constructor(elementRef: ElementRef, dateHelper: DateHelperService, changeDetector: ChangeDetectorRef, datePickerService: DatePickerService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    getInput(partType?: RangePartType): HTMLInputElement;
    focus(): void;
    onFocus(partType?: RangePartType): void;
    onBlur(): void;
    showOverlay(): void;
    hideOverlay(): void;
    showClear(): boolean;
    onClickInputBox(partType?: RangePartType): void;
    onClickBackdrop(): void;
    onOverlayDetach(): void;
    onOverlayKeydown(event: KeyboardEvent): void;
    onPositionChange(position: ConnectedOverlayPositionChange): void;
    onClickClear(event: MouseEvent): void;
    updateInputValue(returnToInit?: boolean): void;
    formatValue(value: CandyDate): string;
    isDisabledDate(date: null | CandyDate): boolean;
    private isValidRange;
    onInputKeyup(event: Event, isEnter?: boolean): void;
    private checkValidInputDate;
    getPlaceholder(partType?: RangePartType): string;
    isEmptyValue(value: CompatibleValue): boolean;
    isOpenHandledByUser(): boolean;
    animationStart(): void;
    animationDone(): void;
}
