/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { AfterContentInit, OnChanges, QueryList, SimpleChanges, TemplateRef } from '@angular/core';
import { NgClassType, NzSizeLDSType } from 'ng-zorro-antd/core/types';
import { NzInputDirective } from './input.directive';
export declare class NzInputGroupComponent implements AfterContentInit, OnChanges {
    listOfNzInputDirective: QueryList<NzInputDirective>;
    nzAddOnBeforeIcon: NgClassType;
    nzAddOnAfterIcon: NgClassType;
    nzPrefixIcon: NgClassType;
    nzSuffixIcon: NgClassType;
    nzAddOnBefore: string | TemplateRef<void>;
    nzAddOnAfter: string | TemplateRef<void>;
    nzPrefix: string | TemplateRef<void>;
    nzSuffix: string | TemplateRef<void>;
    nzSize: NzSizeLDSType;
    nzSearch: boolean;
    nzCompact: boolean;
    isLarge: boolean;
    isSmall: boolean;
    isAffix: boolean;
    isAddOn: boolean;
    updateChildrenInputSize(): void;
    ngAfterContentInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
}
