/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { MediaMatcher } from '@angular/cdk/layout';
import { Platform } from '@angular/cdk/platform';
import { AfterContentInit, AfterViewInit, ChangeDetectorRef, EventEmitter, NgZone, OnChanges, OnDestroy, OnInit, SimpleChanges, TemplateRef } from '@angular/core';
import { NzBreakpointKey } from 'ng-zorro-antd/core/responsive';
import { NzDomEventService } from 'ng-zorro-antd/core/services';
import { NzMenuDirective } from 'ng-zorro-antd/menu';
export declare class NzSiderComponent implements OnInit, AfterViewInit, OnDestroy, OnChanges, AfterContentInit {
    private mediaMatcher;
    private platform;
    private cdr;
    private ngZone;
    private nzDomEventService;
    private destroy$;
    nzMenuDirective: NzMenuDirective | null;
    readonly nzCollapsedChange: EventEmitter<any>;
    nzWidth: string | number;
    nzTheme: 'light' | 'dark';
    nzCollapsedWidth: number;
    nzBreakpoint: NzBreakpointKey | null;
    nzZeroTrigger: TemplateRef<void> | null;
    nzTrigger: TemplateRef<void> | undefined | null;
    nzReverseArrow: boolean;
    nzCollapsible: boolean;
    nzCollapsed: boolean;
    matchBreakPoint: boolean;
    flexSetting: string | null;
    widthSetting: string | null;
    updateStyleMap(): void;
    updateBreakpointMatch(): void;
    updateMenuInlineCollapsed(): void;
    setCollapsed(collapsed: boolean): void;
    constructor(mediaMatcher: MediaMatcher, platform: Platform, cdr: ChangeDetectorRef, ngZone: NgZone, nzDomEventService: NzDomEventService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
}
