/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { NzSafeAny } from 'ng-zorro-antd/core/types';
import { BehaviorSubject, Observable } from 'rxjs';
import { MenuService } from './menu.service';
import { NzMenuModeType } from './menu.types';
export declare class NzSubmenuService {
    private nzHostSubmenuService;
    nzMenuService: MenuService;
    isMenuInsideDropDown: boolean;
    mode$: Observable<NzMenuModeType>;
    level: number;
    isCurrentSubMenuOpen$: BehaviorSubject<boolean>;
    private isChildSubMenuOpen$;
    /** submenu title & overlay mouse enter status **/
    private isMouseEnterTitleOrOverlay$;
    private childMenuItemClick$;
    /**
     * menu item inside submenu clicked
     * @param menu
     */
    onChildMenuItemClick(menu: NzSafeAny): void;
    setOpenStateWithoutDebounce(value: boolean): void;
    setMouseEnterTitleOrOverlayState(value: boolean): void;
    constructor(nzHostSubmenuService: NzSubmenuService, nzMenuService: MenuService, isMenuInsideDropDown: boolean);
}
