/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { ChangeDetectorRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { NzMessageDataFilled, NzMessageDataOptions } from './typings';
export declare class NzMessageComponent implements OnInit, OnDestroy {
    protected cdr: ChangeDetectorRef;
    nzMessage: NzMessageDataFilled;
    nzIndex: number;
    readonly messageDestroy: EventEmitter<{
        id: string;
        userAction: boolean;
    }>;
    protected options: Required<NzMessageDataOptions>;
    private autoClose;
    private eraseTimer;
    private eraseTimingStart;
    private eraseTTL;
    constructor(cdr: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onEnter(): void;
    onLeave(): void;
    protected destroy(userAction?: boolean): void;
    private initErase;
    private updateTTL;
    private startEraseTimeout;
    private clearEraseTimeout;
}
