/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { ElementRef, EventEmitter, OnChanges, SimpleChanges, TemplateRef } from '@angular/core';
import { Location } from '@angular/common';
import { NzConfigService } from 'ng-zorro-antd/core/config';
import { NzPageHeaderBreadcrumbDirective, NzPageHeaderFooterDirective } from './page-header-cells';
export declare class NzPageHeaderComponent implements OnChanges {
    private location;
    nzConfigService: NzConfigService;
    isTemplateRefBackIcon: boolean;
    isStringBackIcon: boolean;
    nzBackIcon: string | TemplateRef<void> | null;
    nzTitle: string | TemplateRef<void>;
    nzSubtitle: string | TemplateRef<void>;
    nzGhost: boolean;
    readonly nzBack: EventEmitter<void>;
    nzPageHeaderFooter: ElementRef<NzPageHeaderFooterDirective>;
    nzPageHeaderBreadcrumb: ElementRef<NzPageHeaderBreadcrumbDirective>;
    constructor(location: Location, nzConfigService: NzConfigService);
    ngOnChanges(changes: SimpleChanges): void;
    onBack(): void;
}
