/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { ChangeDetectorRef, EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { Subject } from 'rxjs';
import { NzFilterFn, NzFilterValue, NzSortCompareFn, NzSortOrderType, NzThFilterType } from '../table.types';
export declare class NzThAddOnComponent implements OnChanges, OnInit, OnDestroy {
    private cdr;
    manualClickOrder$: Subject<NzThAddOnComponent>;
    calcOperatorChange$: Subject<unknown>;
    nzFilterValue: NzFilterValue;
    sortOrder: NzSortOrderType | undefined;
    private sortOrderChange$;
    private destroy$;
    nzSortKey: string;
    nzFilterMultiple: boolean;
    nzSortOrder: NzSortOrderType;
    nzSortPriority: number | boolean;
    nzSortDirections: NzSortOrderType[];
    nzFilters: NzThFilterType;
    nzSortFn: NzSortCompareFn | null;
    nzFilterFn: NzFilterFn | null;
    nzShowSort: boolean;
    nzShowFilter: boolean;
    nzCustomFilter: boolean;
    readonly nzCheckedChange: EventEmitter<boolean>;
    readonly nzSortOrderChange: EventEmitter<NzSortOrderType>;
    readonly nzFilterChange: EventEmitter<any>;
    /** @deprecated use nzSortOrder instead **/
    nzSort: NzSortOrderType;
    /** @deprecated use nzSortOrderChange instead **/
    readonly nzSortChange: EventEmitter<NzSortOrderType>;
    nextSortValue(): void;
    setSortOrder(order: NzSortOrderType): void;
    clearSortOrder(): void;
    onFilterValueChange(value: NzFilterValue): void;
    updateCalcOperator(): void;
    constructor(cdr: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
}
