/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { OnDestroy } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import { NzFilterFn, NzSortCompareFn, NzSortOrderType, NzTableDataType } from './table.types';
export declare class NzTableDataService implements OnDestroy {
    private destroy$;
    private pageIndex$;
    private frontPagination$;
    private pageSize$;
    private listOfData$;
    pageIndexDistinct$: import("rxjs").Observable<number>;
    pageSizeDistinct$: import("rxjs").Observable<number>;
    listOfCalcOperator$: BehaviorSubject<{
        sortFn: NzSortCompareFn | null;
        sortOrder: NzSortOrderType;
        filterFn: NzFilterFn | null;
        filterValue: any;
        sortPriority: number | boolean;
    }[]>;
    private listOfDataAfterCalc$;
    private listOfFrontEndCurrentPageData$;
    listOfCurrentPageData$: import("rxjs").Observable<any[]>;
    total$: import("rxjs").Observable<number>;
    updatePageSize(size: number): void;
    updateFrontPagination(pagination: boolean): void;
    updatePageIndex(index: number): void;
    updateListOfData(list: NzTableDataType[]): void;
    constructor();
    ngOnDestroy(): void;
}
