/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { NzSafeAny } from 'ng-zorro-antd/core/types';
export declare type NzTableDataType = NzSafeAny | {
    [key: string]: NzTableDataType;
};
export declare type NzTableLayoutType = 'fixed' | 'auto';
export declare type NzTablePaginationPositionType = 'top' | 'bottom' | 'both';
export declare type NzTableSizeType = 'middle' | 'default' | 'small';
export declare type NzThFilterType = Array<{
    text: string;
    value: NzSafeAny;
    byDefault?: boolean;
}>;
export interface NzThItemInterface {
    text: string;
    value: NzSafeAny;
    checked: boolean;
}
export declare type NzSortOrderType = string | 'ascend' | 'descend' | null;
export declare type NzSortCompareFn = (a: NzTableDataType, b: NzTableDataType, sortOrder?: NzSortOrderType) => number;
export declare type NzFilterValue = NzSafeAny[] | NzSafeAny;
export declare type NzFilterFn = (value: NzFilterValue, data: NzTableDataType) => boolean;
