/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { Platform } from '@angular/cdk/platform';
import { ChangeDetectorRef, ElementRef, NgZone, OnChanges, TemplateRef } from '@angular/core';
import { NzUpdateHostClassService } from 'ng-zorro-antd/core/services';
import { NgClassType } from 'ng-zorro-antd/core/types';
import { Observable } from 'rxjs';
import { ShowUploadListInterface, UploadFile, UploadListType } from './interface';
declare type UploadListIconType = '' | 'uploading' | 'thumbnail';
interface UploadListFile extends UploadFile {
    isImageUrl?: boolean;
    isUploading?: boolean;
    iconType?: UploadListIconType;
    listItemNameCls?: NgClassType;
    showDownload?: boolean;
}
export declare class NzUploadListComponent implements OnChanges {
    private el;
    private cdr;
    private updateHostClassService;
    private doc;
    private ngZone;
    private platform;
    list: UploadListFile[];
    private get showPic();
    locale: any;
    listType: UploadListType;
    set items(list: UploadFile[]);
    icons: ShowUploadListInterface;
    onPreview: (file: UploadFile) => void;
    onRemove: (file: UploadFile) => void;
    onDownload: (file: UploadFile) => void;
    previewFile: (file: UploadFile) => Observable<string>;
    iconRender: TemplateRef<void>;
    private prefixCls;
    private setClassMap;
    private genErr;
    private extname;
    isImageUrl(file: UploadFile): boolean;
    private getIconType;
    private previewImage;
    private genThumb;
    private listItemNameCls;
    private showDownload;
    private fixData;
    handlePreview(file: UploadFile, e: Event): void;
    handleRemove(file: UploadFile, e: Event): void;
    handleDownload(file: UploadFile): void;
    constructor(el: ElementRef, cdr: ChangeDetectorRef, updateHostClassService: NzUpdateHostClassService, doc: any, // tslint:disable-line no-any
    ngZone: NgZone, platform: Platform);
    detectChanges(): void;
    ngOnChanges(): void;
}
export {};
